"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Select = void 0;

var _react = _interopRequireWildcard(require("react"));

var _GlobalListeners = require("./HOC/GlobalListeners");

var _withTheme = require("./HOC/withTheme");

var _themes = require("../utils/themes");

var _ = require(".");

var _excluded = ["skin", "theme", "themeOverrides", "autoFocus", "context", "allowBlank", "optionHeight", "searchHeight"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var SelectBase = /*#__PURE__*/function (_Component) {
  _inherits(SelectBase, _Component);

  var _super = _createSuper(SelectBase);

  // declare ref types
  // define static properties
  function SelectBase(props) {
    var _this;

    _classCallCheck(this, SelectBase);

    _this = _super.call(this, props); // define ref

    _defineProperty(_assertThisInitialized(_this), "rootElement", void 0);

    _defineProperty(_assertThisInitialized(_this), "inputElement", void 0);

    _defineProperty(_assertThisInitialized(_this), "optionsElement", void 0);

    _defineProperty(_assertThisInitialized(_this), "focus", function () {
      return _this.toggleOpen();
    });

    _defineProperty(_assertThisInitialized(_this), "toggleOpen", function () {
      if (_this.state.isOpen && _this.optionsElement && _this.optionsElement.current) {
        // set Options scroll position to top on close
        _this.optionsElement.current.scrollTop = 0;
      }

      _this.setState({
        isOpen: !_this.state.isOpen
      });
    });

    _defineProperty(_assertThisInitialized(_this), "toggleMouseLocation", function () {
      return _this.setState({
        mouseIsOverOptions: !_this.state.mouseIsOverOptions
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleInputClick", function (event) {
      event.stopPropagation();
      event.preventDefault();

      var _assertThisInitialize = _assertThisInitialized(_this),
          inputElement = _assertThisInitialize.inputElement;

      if (inputElement.current && document.activeElement === inputElement.current) {
        inputElement.current.blur();
      }

      _this.toggleOpen();
    });

    _defineProperty(_assertThisInitialized(_this), "handleChange", function (option, event) {
      // check if the user passed an onChange handler and call it
      if (_this.props.onChange) _this.props.onChange(option.value, event); // onChange is called when an option is selected, so close options

      _this.toggleOpen();
    });

    _defineProperty(_assertThisInitialized(_this), "getSelectedOption", function () {
      var _this$props = _this.props,
          options = _this$props.options,
          value = _this$props.value,
          allowBlank = _this$props.allowBlank;

      var _iterator = _createForOfIteratorHelper(options),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var option = _step.value;
          if (option.value === value) return option;
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      if (!allowBlank) return options[0];
    });

    _this.rootElement = /*#__PURE__*/_react["default"].createRef();
    _this.inputElement = /*#__PURE__*/_react["default"].createRef();
    _this.optionsElement = /*#__PURE__*/_react["default"].createRef();
    var context = props.context,
        themeId = props.themeId,
        theme = props.theme,
        themeOverrides = props.themeOverrides;
    _this.state = {
      composedTheme: (0, _themes.composeTheme)((0, _themes.addThemeId)(theme || context.theme, themeId), (0, _themes.addThemeId)(themeOverrides, themeId), context.ROOT_THEME_API),
      isOpen: false,
      mouseIsOverOptions: false
    };
    return _this;
  }

  _createClass(SelectBase, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      // check for autoFocus of input element
      if (this.props.autoFocus) {
        return this.focus();
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps !== this.props) {
        (0, _themes.didThemePropsChange)(prevProps, this.props, this.setState.bind(this));
      }
    } // ========= PUBLIC SKIN API =========
    // applying focus to the input element will
    // toggle options open because Select's input is read only

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      // destructuring props ensures only the "...rest" get passed down
      var _this$props2 = this.props,
          skin = _this$props2.skin,
          theme = _this$props2.theme,
          themeOverrides = _this$props2.themeOverrides,
          autoFocus = _this$props2.autoFocus,
          context = _this$props2.context,
          allowBlank = _this$props2.allowBlank,
          optionHeight = _this$props2.optionHeight,
          searchHeight = _this$props2.searchHeight,
          rest = _objectWithoutProperties(_this$props2, _excluded);

      var SelectSkin = skin || context.skins[_.IDENTIFIERS.SELECT];
      return /*#__PURE__*/_react["default"].createElement(_GlobalListeners.GlobalListeners, {
        mouseIsOverOptions: this.state.mouseIsOverOptions,
        optionsIsOpen: this.state.isOpen,
        optionsIsOpeningUpward: this.props.isOpeningUpward,
        optionsRef: this.optionsElement,
        rootRef: this.rootElement,
        toggleOpen: this.toggleOpen,
        hasSearch: this.props.hasSearch,
        optionsLength: this.props.options.length
      }, function (_ref) {
        var optionsMaxHeight = _ref.optionsMaxHeight;
        return /*#__PURE__*/_react["default"].createElement(SelectSkin, _extends({
          isOpen: _this2.state.isOpen,
          rootRef: _this2.rootElement,
          inputRef: _this2.inputElement,
          optionsRef: _this2.optionsElement,
          optionsMaxHeight: optionsMaxHeight,
          theme: _this2.state.composedTheme,
          getSelectedOption: _this2.getSelectedOption,
          handleInputClick: _this2.handleInputClick,
          handleChange: _this2.handleChange,
          toggleOpen: _this2.toggleOpen,
          toggleMouseLocation: _this2.toggleMouseLocation,
          optionHeight: optionHeight,
          searchHeight: searchHeight
        }, rest));
      });
    }
  }]);

  return SelectBase;
}(_react.Component);

_defineProperty(SelectBase, "displayName", 'Select');

_defineProperty(SelectBase, "defaultProps", {
  allowBlank: true,
  autoFocus: false,
  context: (0, _withTheme.createEmptyContext)(),
  isOpeningUpward: false,
  options: [],
  theme: null,
  themeOverrides: {},
  themeId: _.IDENTIFIERS.SELECT,
  value: ''
});

var Select = (0, _withTheme.withTheme)(SelectBase);
exports.Select = Select;
//# sourceMappingURL=Select.js.map