"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormFieldSkin = FormFieldSkin;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _PopOver = require("../../components/PopOver");

var _SimpleFormField = require("../../themes/simple/SimpleFormField");

var _hooks = require("../../utils/hooks");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function FormFieldSkin(props) {
  var updateOnRefChanges = (0, _hooks.manageRef)(props.formFieldRef);
  var isFormFieldFocused = (0, _hooks.handleRefState)(props.formFieldRef, {
    on: 'focus',
    off: 'blur'
  });
  var isFormFieldHovered = (0, _hooks.handleRefState)(props.formFieldRef, {
    on: 'mouseenter',
    off: 'mouseleave'
  });
  var hasError = props.error != null;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])([props.className, props.theme[props.themeId].root, props.disabled ? props.theme[props.themeId].disabled : null, props.error ? props.theme[props.themeId].errored : null]),
    style: props.themeVariables
  }, props.label && /*#__PURE__*/_react["default"].createElement("label", {
    role: "presentation",
    "aria-hidden": true,
    className: props.theme[props.themeId].label,
    onClick: props.focusChild,
    htmlFor: props.id
  }, props.label), /*#__PURE__*/_react["default"].createElement(_PopOver.PopOver, {
    visible: props.isErrorShown === true || props.isErrorHidden !== true && hasError && (props.isShowingErrorOnFocus && isFormFieldFocused || props.isShowingErrorOnHover && isFormFieldHovered),
    content: props.error,
    themeVariables: _objectSpread({
      '--rp-pop-over-bg-color': "var(".concat(_SimpleFormField.SimpleFormFieldVariables.errorColor)
    }, props.themeVariables),
    placement: "bottom",
    popperOptions: {
      modifiers: [{
        name: 'flip',
        enabled: false
      }]
    },
    duration: [300, 0]
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: props.theme[props.themeId].inputWrapper
  }, props.render(updateOnRefChanges))));
}
//# sourceMappingURL=FormFieldSkin.js.map